module declse_eg10.
export numsals[ff].
@no_preprocessing +.
@sup_magic_indexing -.
@sup_magic +.
@existential -.
@factoring -.
@magic -.
@no_rewriting -.
@ordered_search +.
@save_module -.
@pipelining -.
@single_scc -.
@allowed_adornments  sals[ff].
@allowed_adornments  sals[bf].
@allowed_adornments  budget[ff].
@allowed_adornments  budget[bf].
@allowed_adornments  employees2[ff].
@allowed_adornments  employees2[bf].
@check_subsumption +.
@multiset -.
@index_deltas +.
@return_unify -.
@convert_functions -.
@non_ground_facts +.
@lazy_eval -.
@monotonic -.
@psn -.
m_sals() :- 
		m_numsals().
numsals(Dept,N) :- 
		m_numsals(), 
		sals(Dept,S), 
		count(S,N).
_-: m_works() :- 
		m_sals().
sals(Dept,makeset(<Sal>)) :- 
		m_sals(), 
		done_m_works(), 
		works(E,Dept,Sal).
works(joe,toy,20) :- 
		m_works().
works(jim,toy,20) :- 
		m_works().
works(jane,sales,30) :- 
		m_works().
end_module.

module declse_eg11.
export sals[ff].
@no_preprocessing +.
@sup_magic_indexing -.
@sup_magic +.
@existential -.
@factoring -.
@magic -.
@no_rewriting -.
@ordered_search +.
@save_module -.
@pipelining -.
@single_scc -.
@allowed_adornments  sals[ff].
@allowed_adornments  sals[bf].
@allowed_adornments  budget[ff].
@allowed_adornments  budget[bf].
@allowed_adornments  employees2[ff].
@allowed_adornments  employees2[bf].
@check_subsumption +.
@multiset -.
@index_deltas +.
@return_unify -.
@convert_functions -.
@non_ground_facts +.
@lazy_eval -.
@monotonic -.
@psn -.
_-: m_works() :- 
		m_sals().
sals(Dept,makeset(<Sal>)) :- 
		m_sals(), 
		done_m_works(), 
		works(E,Dept,Sal).
works(joe,toy,20) :- 
		m_works().
works(jim,toy,20) :- 
		m_works().
works(jane,sales,30) :- 
		m_works().
end_module.

module declse_eg12.
export budget[ff].
@no_preprocessing +.
@sup_magic_indexing -.
@sup_magic +.
@existential -.
@factoring -.
@magic -.
@no_rewriting -.
@ordered_search +.
@save_module -.
@pipelining -.
@single_scc -.
@allowed_adornments  sals[ff].
@allowed_adornments  sals[bf].
@allowed_adornments  budget[ff].
@allowed_adornments  budget[bf].
@allowed_adornments  employees2[ff].
@allowed_adornments  employees2[bf].
@check_subsumption +.
@multiset -.
@index_deltas +.
@return_unify -.
@convert_functions -.
@non_ground_facts +.
@lazy_eval -.
@monotonic -.
@psn -.
_-: m_works() :- 
		m_budget().
budget(Dept,sum(<Sal>)) :- 
		m_budget(), 
		done_m_works(), 
		works(E,Dept,Sal).
works(joe,toy,20) :- 
		m_works().
works(jim,toy,20) :- 
		m_works().
works(jane,sales,30) :- 
		m_works().
end_module.

module declse_eg13.
export employees[ff].
@no_preprocessing +.
@sup_magic_indexing -.
@sup_magic +.
@existential -.
@factoring -.
@magic -.
@no_rewriting -.
@ordered_search +.
@save_module -.
@pipelining -.
@single_scc -.
@allowed_adornments  sals[ff].
@allowed_adornments  sals[bf].
@allowed_adornments  budget[ff].
@allowed_adornments  budget[bf].
@allowed_adornments  employees2[ff].
@allowed_adornments  employees2[bf].
@check_subsumption +.
@multiset -.
@index_deltas +.
@return_unify -.
@convert_functions -.
@non_ground_facts +.
@lazy_eval -.
@monotonic -.
@psn -.
m_works() :- 
		m_employees().
employees(Dept,S) :- 
		m_employees(), 
		works(E,Dept,Sal), 
		create_set(S), 
		add_elem(S,E).
works(joe,toy,20) :- 
		m_works().
works(jim,toy,20) :- 
		m_works().
works(jane,sales,30) :- 
		m_works().
end_module.

module declse_eg14.
export works[fff].
@no_preprocessing +.
@sup_magic_indexing -.
@sup_magic +.
@existential -.
@factoring -.
@magic -.
@no_rewriting -.
@ordered_search +.
@save_module -.
@pipelining -.
@single_scc -.
@allowed_adornments  sals[ff].
@allowed_adornments  sals[bf].
@allowed_adornments  budget[ff].
@allowed_adornments  budget[bf].
@allowed_adornments  employees2[ff].
@allowed_adornments  employees2[bf].
@check_subsumption +.
@multiset -.
@index_deltas +.
@return_unify -.
@convert_functions -.
@non_ground_facts +.
@lazy_eval -.
@monotonic -.
@psn -.
works(joe,toy,20) :- 
		m_works().
works(jim,toy,20) :- 
		m_works().
works(jane,sales,30) :- 
		m_works().
end_module.

module declse_eg15.
export employees2[ff].
@no_preprocessing +.
@sup_magic_indexing -.
@sup_magic +.
@existential -.
@factoring -.
@magic -.
@no_rewriting -.
@ordered_search +.
@save_module -.
@pipelining -.
@single_scc -.
@allowed_adornments  sals[ff].
@allowed_adornments  sals[bf].
@allowed_adornments  budget[ff].
@allowed_adornments  budget[bf].
@allowed_adornments  employees2[ff].
@allowed_adornments  employees2[bf].
@check_subsumption +.
@multiset -.
@index_deltas +.
@return_unify -.
@convert_functions -.
@non_ground_facts +.
@lazy_eval -.
@monotonic -.
@psn -.
_-: m_works() :- 
		m_employees2().
employees2(Dept,<E>) :- 
		m_employees2(), 
		done_m_works(), 
		works(E,Dept,Sal).
works(joe,toy,20) :- 
		m_works().
works(jim,toy,20) :- 
		m_works().
works(jane,sales,30) :- 
		m_works().
end_module.

module declse_eg16.
export phones[ff].
@no_preprocessing +.
@sup_magic_indexing -.
@sup_magic +.
@existential -.
@factoring -.
@magic -.
@no_rewriting -.
@ordered_search +.
@save_module -.
@pipelining -.
@single_scc -.
@allowed_adornments  sals[ff].
@allowed_adornments  sals[bf].
@allowed_adornments  budget[ff].
@allowed_adornments  budget[bf].
@allowed_adornments  employees2[ff].
@allowed_adornments  employees2[bf].
@check_subsumption +.
@multiset -.
@index_deltas +.
@return_unify -.
@convert_functions -.
@non_ground_facts +.
@lazy_eval -.
@monotonic -.
@psn -.
phones(Dept,{"2-5171","2-6172"}) :- 
		m_phones(), 
		employees1(Dept,{jim,joe}).
end_module.

