
module declse_eg33.
@pipelining.

export multiset_to_list(bf).

% The first argument must be bound to a multiset; returns a list
% with the same elements.

multiset_to_list(S, L) :- 
	convert(S, [], L).		

convert(S, Lin, Lout) :- 
	member(S, X),!, %print(1,X),			% member is now used on a relation
	create_set(S1), %print(2,S1),
	add_elem(X,S1,S2), %print(3,S1),
	difference(S,S2,S3), 
	convert(S3, [X|Lin], Lout),!.

convert({}, L, L):- !.

end_module.


